<!DOCTYPE html>
<html lang="en">

<head>
    <title>Task 68</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

    <div class="container">
        <h2 style="text-align: center;">Quản trị Menu</h2>
        <div class="jumbotron container">
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="size">Size</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-size" name="size" placeholder="Size" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="duongkinh">Đường kính</label>
                </div>
                <div class="col-sm-9">
                    <input type="number" id="input-duong-kinh" name="duongkinh" placeholder="Đường kính" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="suon">Sườn</label>
                </div>
                <div class="col-sm-9">
                    <input type="number" id="input-suon" name="suon" placeholder="Sườn" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="salad">Salad</label>
                </div>
                <div class="col-sm-9">
                    <input id="input-salad" name="salad" placeholder="Salad" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="soluongnuocngot">Số lượng nước ngọt</label>
                </div>
                <div class="col-sm-9">
                    <input id="input-so-luong-nuoc-ngot" name="so-luong-nuoc-ngot" placeholder="Số lượng nước ngọt" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="dongia">Đơn giá</label>
                </div>
                <div class="col-sm-9">
                    <input id="input-don-gia" name="don-gia" placeholder="Đơn giá" class="form-control">
                </div>
            </div>
            <div class="row text-right">
                <div class="col-sm-12">
                    <button id="create-menu" class="btn btn-success">Tạo mới</button>
                </div>
            </div>
        </div>

        <table class="table table-bordered table-striped table-hover" id="menu-table">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Size</th>
                    <th>Đường kính</th>
                    <th>Sườn</th>
                    <th>Salad</th>
                    <th>Số lượng nước ngọt</th>
                    <th>Đơn giá</th>
                    <th>Action</th>
                </tr>
        </table>

        <!-- Update menu modal -->
        <div id="update-menu-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Chi tiết menu</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-size">Size</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-size" name="size" placeholder="Size" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-duong-kinh">Đường kính</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-duong-kinh" name="duongkinh" placeholder="Đường kính" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-suon">Sườn</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-suon" name="suon" placeholder="Sườn" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-salad">Salad</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-salad" name="salad" placeholder="Salad" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-so-luong-nuoc-ngot">Số lượng nước ngọt</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-so-luong-nuoc-ngot" name="soluongnuocngot" placeholder="Số lượng nước ngọt" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-don-gia">Đơn giá</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-don-gia" name="dongia" placeholder="Đơn giá" class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-success" id="btn-update-menu">Update Menu</button>
                        <button class="btn btn-danger" id="btn-update-menu" data-dismiss="modal">Menu</button>
                    </div>
                </div>
            </div>
        </div>
        <!-- Delete confirm modal -->
        <div>
            <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">Confirm xóa menu</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <label>Bạn có chắc chắn muốn xóa menu này không?</label>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-confirm-delete-menu">Xác nhận</button>
                            <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                        </div>
                    </div>
                </div>
            </div>
</body>
<script>
    // khai báo biến mảng hằng số chứa danh sách tên các thuộc tính
    const gMENU_COLS = ["id", "size", "duongKinh", "suon", "salad", "soLuongNuocNgot", "donGia", "action"];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gMENU_ID_COL = 0;
    const gMENU_SIZE_COL = 1;
    const gMENU_DUONG_KINH_COL = 2;
    const gMENU_SUON_COL = 3;
    const gMENU_SALAD_COL = 4;
    const gMENU_SO_LUONG_NUOC_NGOT_COL = 5;
    const gMENU_DON_GIA_COL = 6;
    const gMENU_ACTION_COL = 7;
    // Đổ dữ liệu vào bàng và thực hiện nút Sửa (Edit), Xóa (Delete)
    $("#menu-table").DataTable({
        columns: [{
            data: gMENU_COLS[gMENU_ID_COL]
        }, {
            data: gMENU_COLS[gMENU_SIZE_COL]
        }, {
            data: gMENU_COLS[gMENU_DUONG_KINH_COL]
        }, {
            data: gMENU_COLS[gMENU_SUON_COL]
        }, {
            data: gMENU_COLS[gMENU_SALAD_COL]
        }, {
            data: gMENU_COLS[gMENU_SO_LUONG_NUOC_NGOT_COL]
        }, {
            data: gMENU_COLS[gMENU_DON_GIA_COL]
        }, {
            data: gMENU_COLS[gMENU_ACTION_COL]
        }],
        columnDefs: [{
            // định nghĩa lại cột Action
            targets: gMENU_ACTION_COL,
            className: "text-center",
            defaultContent: `
                <button class = "btn btn-primary btn-edit">Sửa</button>
                <button class = "btn btn-danger btn-delete" data-toggle='modal'>Xóa</button>
                `
        }, {
            targets: gMENU_SO_LUONG_NUOC_NGOT_COL,
            className: "text-center",
        }],
        autoWidth: false
    });

    $(document).ready(function() {
        var gListMenu = [];
        var gMenuId = "";
        onPageLoading();
        // gán sự kiện cho nút Create Voucher (trên modal)
        $("#create-menu").on("click", function() {
            onBtnCreateMenuClick();
        });
        // Gán sự kiện Update - Sửa 1 Voucher
        $("#menu-table").on("click", ".btn-edit", function() {
            onBtnEditClick(this);
        });
        // gán sự kiện cho nút Update Voucher (trên modal)
        $("#btn-update-menu").on("click", function() {
            onBtnUpdateMenuClick();
        });
        // Gán sự kiện Delete - Xóa 1 Voucher
        $("#menu-table").on("click", ".btn-delete", function() {
                onBtnDeleteClick(this);
            })
            // gán sự kiện cho nút Delete Voucher (trên modal)
        $("#btn-confirm-delete-menu").on("click", function() {
                onBtnConfirmDeleteMenuClick();
            })
            /** REGION 4: Common function: Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
        function onPageLoading() {
            "use strict";
            getAllMenu();
            //1: Read/Load user to DataTable
            loadDataToMenuTable(gListMenu);
        }

        function getAllMenu() {
            "use strict";
            $.ajax({
                url: "http://localhost:8080/menu/all",
                type: "GET",
                dataType: 'json',
                async: false,
                success: function(responseObject) {
                    console.log(responseObject);
                    //lấy response trả về và gán cho biến gListVouchers
                    gListMenu = responseObject;
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        // Load voucher vào DataTable
        function loadDataToMenuTable(paramObjectMenu) {
            console.log(paramObjectMenu);
            var vTable = $("#menu-table").DataTable();
            vTable.clear();
            vTable.rows.add(paramObjectMenu);
            vTable.draw();
        }


        // Hàm xử lý sự kiện khi nút Thêm voucher được nhấn
        function onBtnCreateMenuClick() {
            "use strict";
            //khai báo đối tượng chứa user data
            var vMenuObj = {
                    size: "",
                    duongKinh: "",
                    suon: "",
                    salad: "",
                    soLuongNuocNgot: "",
                    donGia: ""
                }
                // B1: thu thập dữ liệu
            getMenuDataCreate(vMenuObj);
            //B2: Validate Insert
            var vIsMenuValidate = validateInsertData(vMenuObj);
            if (vIsMenuValidate) {
                // B3: Insert user
                postMenuApi(vMenuObj);
                //B4: xử lý hiển thị
                //gọi API lấy danh sách user
                getAllMenu();
                //load dữ liệu vào bảng
                loadDataToMenuTable(gListMenu);
                // xóa trắng dữ liệu trên modal
                resertCreateMenuForm();
            }

        }
        // hàm thu thập dữ liệu để create voucher
        function getMenuDataCreate(paramMenuObj) {
            "use strict";
            paramMenuObj.size = $("#input-size").val().trim();
            paramMenuObj.duongKinh = $("#input-duong-kinh").val().trim();
            paramMenuObj.suon = $("#input-suon").val().trim();
            paramMenuObj.salad = $("#input-salad").val().trim();
            paramMenuObj.soLuongNuocNgot = $("#input-so-luong-nuoc-ngot").val().trim();
            paramMenuObj.donGia = $("#input-don-gia").val().trim();
        }

        function validateInsertData(paramMenuObj) {
            "use strict";
            if (paramMenuObj.size === "") {
                alert("Bạn cần nhập size!");
                return false;
            }
            if (paramMenuObj.duongKinh === "") {
                alert("Bạn cần nhập đường kính!");
                return false;
            }
            if (paramMenuObj.suon === "") {
                alert("Bạn cần nhập số lượng sườn!");
                return false;
            }
            if (paramMenuObj.salad === "") {
                alert("Bạn cần nhập số lượng salad!");
                return false;
            }
            if (paramMenuObj.soLuongNuocNgot === "") {
                alert("Bạn cần nhập số lượng nước ngọt!");
                return false;
            }
            if (paramMenuObj.donGia === "") {
                alert("Bạn cần nhập đơn giá!");
                return false;
            }
            return true;
        }

        function postMenuApi(paramMenuObj) {
            "use strict";
            $.ajax({
                async: false,
                url: "http://localhost:8080/menu/create",
                type: "POST",
                data: JSON.stringify(paramMenuObj),
                contentType: "application/json",
                success: function(res) {
                    console.log(res);
                    alert("Thêm menu thành công!");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }

        function resertCreateMenuForm() {
            "use strict";
            $("#input-size").val("");
            $("#input-duong-kinh").val("");
            $("#input-suon").val("");
            $("#input-salad").val("");
            $("#input-so-luong-nuoc-ngot").val("");
            $("#input-don-gia").val("");
        }

        function onBtnEditClick(paramButtonElement) {
            "use strict";
            console.log("Nút Sửa được nhấn!");
            var vRowClick = $(paramButtonElement).closest("tr"); // xác định tr chứa nút bấm được click
            var vTable = $("#menu-table").DataTable(); // tạo biến truy xuất đến DataTable
            var vDataRow = vTable.row(vRowClick).data(); // Dữ liệu của hàng dữ liệu chứa nút bấm được click
            console.log("ID của menu tương ứng = " + vDataRow.id);
            gMenuId = vDataRow.id;
            $("#input-update-size").val(vDataRow.size);
            $("#input-update-duong-kinh").val(vDataRow.duongKinh);
            $("#input-update-suon").val(vDataRow.suon);
            $("#input-update-salad").val(vDataRow.salad);
            $("#input-update-so-luong-nuoc-ngot").val(vDataRow.soLuongNuocNgot);
            $("#input-update-don-gia").val(vDataRow.donGia);
            $("#update-menu-modal").modal("show");
        }

        function onBtnUpdateMenuClick() {
            "use strict";
            var vMenuObj = {
                size: "",
                duongKinh: "",
                suon: "",
                salad: "",
                soLuongNuocNgot: "",
                donGia: ""
            }
            vMenuObj.size = $("#input-update-size").val().trim();
            vMenuObj.duongKinh = $("#input-update-duong-kinh").val().trim();
            vMenuObj.suon = $("#input-update-suon").val().trim();
            vMenuObj.salad = $("#input-update-salad").val().trim();
            vMenuObj.soLuongNuocNgot = $("#input-update-so-luong-nuoc-ngot").val().trim();
            vMenuObj.donGia = $("#input-update-don-gia").val().trim();
            console.log(vMenuObj);
            var vIsMenuUpdateValidate = validateUpdateData(vMenuObj);
            if (vIsMenuUpdateValidate) {
                // B3: Update user
                putMenuUpdateApi(vMenuObj);
                //B4: xử lý hiển thị
                //gọi API lấy danh sách user
                getAllMenu();
                //load dữ liệu vào bảng
                loadDataToMenuTable(gListMenu);
                // xóa trắng dữ liệu trên modal
                resertUpdateMenuModal();
                // ẩn modal form
                $("#update-menu-modal").modal("hide");
            }
        }

        function validateUpdateData(paramMenuObj) {
            "use strict";
            if (paramMenuObj.size === "") {
                alert("Bạn cần nhập size!");
                return false;
            }
            if (paramMenuObj.duongKinh === "") {
                alert("Bạn cần nhập đường kính!");
                return false;
            }
            if (paramMenuObj.suon === "") {
                alert("Bạn cần nhập sườn!");
                return false;
            }
            if (paramMenuObj.salad === "") {
                alert("Bạn cần nhập salad!");
                return false;
            }
            if (paramMenuObj.soLuongNuocNgot === "") {
                alert("Bạn cần nhập số lượng nước ngọt!");
                return false;
            }
            if (paramMenuObj.donGia === "") {
                alert("Bạn cần nhập đơn giá!");
                return false;
            }
            return true;
        }

        function resertUpdateMenuModal() {
            "use strict";
            $("#input-update-size").val("");
            $("#input-update-duong-kinh").val("");
            $("#input-update-suon").val("");
            $("#input-update-salad").val("");
            $("#input-update-so-luong-nuoc-ngot").val("");
            $("#input-update-don-gia").val("");
        }

        function putMenuUpdateApi(paramMenuObj) {
            "use strict";
            $.ajax({
                async: false,
                url: "http://localhost:8080/menu/update/" + gMenuId,
                type: "PUT",
                data: JSON.stringify(paramMenuObj),
                contentType: "application/json;charset=UTF-8",
                success: function(res) {
                    console.log(res);
                    alert("Update menu thành công!");
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }

        function onBtnDeleteClick(paramButtonElement) {
            "use strict";
            console.log("Nút Xóa được nhấn!");
            var vRowClick = $(paramButtonElement).closest("tr"); // xác định tr chứa nút bấm được click
            var vTable = $("#menu-table").DataTable(); // tạo biến truy xuất đến DataTable
            var vDataRow = vTable.row(vRowClick).data(); // Dữ liệu của hàng dữ liệu chứa nút bấm được click
            console.log("ID của menu tương ứng = " + vDataRow.id);
            $("#delete-confirm-modal").modal("show");
            gMenuId = vDataRow.id;
        }

        function onBtnConfirmDeleteMenuClick() {
            //khai báo đối tượng chưa voucher data (bỏ qua)
            //B1: Thu thập dữ liệu (bỏ qua)
            //B2: Validate delete data (bỏ qua)
            //B3: Delete voucher
            deleteMenuApi(gMenuId);
            alert("Xóa menu thành công!");
            getAllMenu();
            //load dữ liệu vào bảng
            loadDataToMenuTable(gListMenu);
            $("#delete-confirm-modal").modal("hide");

        }

        function deleteMenuApi(paramMenuId) {
            "use strict";
            $.ajax({
                async: false,
                url: "http://localhost:8080/menu/delete/" + gMenuId,
                type: "DELETE",
                data: 'json',
                success: function(res) {
                    console.log(res);
                    gListMenu = res;
                },
                error: function(error) {
                    alert(error.responseText);
                }
            })
        }


    });
</script>

</html>
​